//(c) Ilya Mamontov 2011, 2012
//http://antiradio.narod.ru/x-meter
//       .
//    readme.txt

//---------------------------------------------------------------------------
//01 - ,  : . .= "+" -- , "-" -- !!!
//03 - - 
//04 -    , ,   
//05 -    ( CR  CZ     W1  W2 --    )
//06 -    CR  CZ,    W1  W2
//07,08 - 
//09 -  ,  
//10 -    ohm-K-M-G,  
//11 -   C
//12-1 - 2 ,  
//12-2 - 2 ,  .
//12-4 - 2 ,   C  L   .
//     - ESR  L --   ,   C --  
//     -     
//12-5 -    L-C   R
//     -    CCR  CR     1 
//13-1 -      1,1  ( CR  CCR)
//14-2 -       ini  CCZ  CCR (  !,        )
//15-1 -    Image1 -    ( Canvas  PaintBox1    )
//     -   ImageList (    ),   --    Image,      

//15-1tpl -    .
//         :
//        -     16   44100 
//        -   11025      
//        -     ,     11025    .
//        -         
//        -       ("  ")

#include <vcl\vcl.h>
#pragma hdrstop
#include <math.h>
//#include <complex.h>

#include<io.h>
#include <fcntl.h>

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//char inBuf[256];                //   
//char inifile[]="./RLCmeter.ini";// ini-

//--   
WAVEHDR      WaveHdr1={0};
WAVEHDR      WaveHdr2={0};
HANDLE       hData  = NULL;// handle of waveform data memory
LPSTR        lpData = NULL;// pointer to waveform data memory
HWAVEIN      hDevice;      // 
WAVEFORMATEX strFormat;    //  -.
MMRESULT     result;       //  -
bool         NonStop;      // 
int          dwDataSize;   //    

//--   
WAVEHDR      WaveHdrPlay1={0};
WAVEHDR      WaveHdrPlay2={0};
HWAVEOUT     hDevicePlay;      // 
int          dwDataSizePlay;   //      

// 
int x1,y1,x2,y2;               // 

//  
float alpha=0; //   ,    (0 - ., 9 - .)
//float val=0;   //  

//   
__int64 interval=0;          //  
LARGE_INTEGER Frequency; // 
LARGE_INTEGER Start_time;//  
LARGE_INTEGER Stop_time; //  


//------------------------------------------------------------------
void  Processing(void)
{//  ,  
//  
float xx1=(float)x1*2/dwDataSize; //
float yy1=(float)y1*2/dwDataSize; //
float a1=sqrt(xx1*xx1+yy1*yy1); //   
//  
float xx2=(float)x2*2/dwDataSize; //
float yy2=(float)y2*2/dwDataSize; //
float a2=sqrt(xx2*xx2+yy2*yy2); //   

// 
Form1->Panel1->Caption=FloatToStrF(a2,ffFixed,10,2);  //      

//  
Form1->PaintBox1->Canvas->Pen->Color=Form1->PaintBox1->Canvas->Pixels[0][0];//      
Form1->PaintBox1->Canvas->MoveTo(128,230);
Form1->PaintBox1->Canvas->LineTo(128+195*cos(2.152-alpha*0.13),230-195*sin(2.152-alpha*0.13));
//  a2    alpha (0 --  , 9 --   )
 if(a2>128) alpha=log(a2)/log(2.0)-6; else alpha=a2/128;// 128  
//   (alpha=0...)
Form1->PaintBox1->Canvas->Pen->Color=0x00FF;
Form1->PaintBox1->Canvas->MoveTo(128,230);
Form1->PaintBox1->Canvas->LineTo(128+195*cos(2.152-alpha*0.13),230-195*sin(2.152-alpha*0.13)); //  

//    -    Shape1 ()  Shape2 ()
int level=a1*119/32768;             //   
if(level<119){Form1->Shape1->Width=level; Form1->Shape2->Width=0; }// 
         else{Form1->Shape1->Width=119;   Form1->Shape2->Width=2; }//


}
//---------------------------------------------------------------------------
//CALLBACK- 
void CALLBACK callback_record_fun(HWND hWnd, UINT msg, DWORD dwInstance, LPWAVEHDR lpWaveHdr, LPARAM lParam)
{//lpWaveHdr - Address of a WAVEHDR structure that identifies the buffer containing the data.
// x1,y1,x2,y2
short* i;
short* ii;

switch (msg)
{case WIM_DATA: {
  //     
  QueryPerformanceCounter(&Start_time); //  

  x1=y1=x2=y2=0; //  
  //    -----------------------
  i=(short*)lpWaveHdr->lpData;                 //  
  ii=(short*)((int)i+lpWaveHdr->dwBufferLength);      //      dwDataSize*2
  for(i;i<ii;)//       
                           {//  (   -   )
                            x1+=*i++;     //   ()
                                x2+=*i++;               //()
                            y1+=*i++;     // 
                                y2+=*i++;
                            x1-=*i++;     // 
                                x2-=*i++;
                            y1-=*i++;     // 
                                y2-=*i++;
                           }; //for i
  //    --------------------------
  if(NonStop)//     
             {lpWaveHdr->dwFlags=0;
              waveInPrepareHeader(hDevice, lpWaveHdr, sizeof(WAVEHDR));
              UINT wResult=waveInAddBuffer(hDevice, lpWaveHdr, sizeof(WAVEHDR));
              if (wResult != 0){NonStop=false;
                                waveInReset(hDevice);
                                waveInClose(hDevice);
                                ShowMessage("Command waveInAddBuffer is failed");
                                return;
                               }
             Processing();  //    
             }//if NonStop


  //     
  QueryPerformanceCounter(&Stop_time);   //  
  interval=Stop_time.QuadPart-Start_time.QuadPart;
  //    
  Form1->StatusBar1->Panels->Items[0]->Text="CPU: "+FloatToStrF(100.0*interval*strFormat.nSamplesPerSec/Frequency.QuadPart/dwDataSize,ffFixed,10,2)+"% load";


  }; //case WIM_DATA
 break;
 } //switch
}
//---------------------------------------------------------------------------
//CALLBACK- 
void CALLBACK callback_play_fun(HWND hWnd, UINT msg, DWORD dwInstance, LPWAVEHDR lpWaveHdr, LPARAM lParam)
{//lpWaveHdr - Address of a WAVEHDR structure that identifies the buffer containing the data.
switch (msg)
{case WOM_DONE:
  {  if (NonStop)//   ,    
              {lpWaveHdr->dwFlags =0;
               waveOutPrepareHeader(hDevicePlay, lpWaveHdr, sizeof(WAVEHDR));
               UINT wResult= waveOutWrite(hDevicePlay, lpWaveHdr, sizeof(WAVEHDR));
               if (wResult != 0){NonStop=false;
                                 waveOutReset(hDevicePlay);
                                 waveOutClose(hDevicePlay);
                                 ShowMessage("Command waveOutWrite is failed");
                                 return;
                                }
              }//if NonStop


  }; //case WOM_DONE
 break;
 } //switch
}
//------------------------------------------------------------------
void  PrepareAll (void)
// ,     CallBack-
{
// -    -     strFormat
strFormat.wFormatTag=1;        //  = WAVE_FORMAT_PCM
strFormat.nChannels=2;         //
strFormat.nSamplesPerSec=44100;//22050;//44100;
strFormat.nBlockAlign=4;       //.   
strFormat.wBitsPerSample=16;   // 
strFormat.nAvgBytesPerSec=strFormat.nSamplesPerSec*strFormat.nBlockAlign;
strFormat.cbSize=0;

//    ----------------------------
result=waveOutOpen((LPHWAVEOUT)&hDevicePlay, WAVE_MAPPER, &strFormat, (DWORD)callback_play_fun, 0, CALLBACK_FUNCTION);
//   -
if (result) {ShowMessage("Unable to open output audio device");return;}


//    ----------------------------
result=waveInOpen((LPHWAVEIN)&hDevice, WAVE_MAPPER, &strFormat, (DWORD)callback_record_fun, 0, CALLBACK_FUNCTION);
//   -
if (result) {ShowMessage("Unable to open input audio device");return;}

// header-1  header-2.
WaveHdr1.lpData         =lpData;
WaveHdr1.dwBufferLength =dwDataSize*strFormat.nBlockAlign;  // 

WaveHdr2.lpData         =lpData+WaveHdr1.dwBufferLength;
WaveHdr2.dwBufferLength =WaveHdr1.dwBufferLength;           // 

// header-1  header-2  .
WaveHdrPlay1.lpData         =lpData+2*dwDataSize*strFormat.nBlockAlign;
WaveHdrPlay1.dwBufferLength =dwDataSizePlay*strFormat.nBlockAlign;    // 
WaveHdrPlay1.dwLoops        =0;

WaveHdrPlay2.lpData         =WaveHdrPlay1.lpData+WaveHdrPlay1.dwBufferLength;
WaveHdrPlay2.dwBufferLength =WaveHdrPlay1.dwBufferLength;   // 
WaveHdrPlay2.dwLoops        =0;

//   1/4 F
short* p=(short*)WaveHdrPlay1.lpData;   //  
for(int i=0; i<dwDataSizePlay*2;i++)//     (2  )
                           {short a1; if((i&2)==0) a1=-32000; else a1=32000;
                                      if((i&1)!=0) a1=0;   //     !!!
                            *p++=a1; //   1- () 
                            *p++=a1; //   2- () 
                           }//for i

}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{// 

//       (   . . )
bool id=QueryPerformanceFrequency(&Frequency);  //   1   
if(!id) {ShowMessage("CPU is 4x86 or lower"); return;}     //    


//   ini-
//----  CK (   )
//		GetPrivateProfileString ("Startup", "CK_real","1.0",inBuf, sizeof(inBuf) ,inifile);
//		float f1=atof(inBuf);

// 
PaintBox1->Canvas->Pen->Width=2;   // 


dwDataSize=4080*5;     //      (  )
dwDataSizePlay=8200;   //    4096 -   

//   2       .
hData = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, (dwDataSize+dwDataSizePlay)*4 *2); //     (+.) * 4    () * 2 
if(!hData){ShowMessage("Out of memory for buffer"); return;}
lpData = (LPSTR)GlobalLock(hData);
if(lpData==NULL){ShowMessage("Failed to lock memory");  GlobalFree(hData);  return;}

NonStop=true;      //   .
PrepareAll();      //   !

//   
callback_play_fun(0,WOM_DONE,0,(LPWAVEHDR)&WaveHdrPlay1,0); //  .  1- 
callback_play_fun(0,WOM_DONE,0,(LPWAVEHDR)&WaveHdrPlay2,0); //      2- 

//    
waveInStart(hDevice);
callback_record_fun(0,WIM_DATA,0,(LPWAVEHDR)&WaveHdr1,0); //  .  1- 
callback_record_fun(0,WIM_DATA,0,(LPWAVEHDR)&WaveHdr2,0); //      2- 

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{// 
NonStop=false;
waveInStop(hDevice);
waveInClose(hDevice);
waveOutReset(hDevicePlay);
waveOutClose(hDevicePlay);
GlobalUnlock(hData);
GlobalFree(hData);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{//
ShowMessage(Memo2->Text);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintBox1Paint(TObject *Sender)
{//  
//  
Form1->PaintBox1->Canvas->Brush->Color=0x00;              // 
PaintBox1->Canvas->FillRect(PaintBox1->Canvas->ClipRect); //  
PaintBox1->Canvas->Draw(0,0, Image3->Picture->Graphic);   //   ()

}
//---------------------------------------------------------------------------
